unit austeilunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  CheckLst, base;




type

  { TAusteilForm }

  TAusteilForm = class(TForm)
    BT_Abbrechen: TButton;
    BT_Austeil: TButton;
    BT_hinzufuegen: TButton;
    CLB_Files: TCheckListBox;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    procedure BT_AbbrechenClick(Sender: TObject);
    procedure BT_AusteilClick(Sender: TObject);
    procedure BT_hinzufuegenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    MResult : TModalResult;
    { public declarations }
  end;


var
  AusteilForm : TAusteilForm;
  AusteilPfad : String;

implementation

{$R *.lfm}

{ TAusteilForm }

procedure TAusteilForm.BT_hinzufuegenClick(Sender: TObject);
Var
  dest : String;
begin
  OpenDialog1.InitialDir:=AusteilPfad;
  Opendialog1.DoFolderChange;
  if OpenDialog1.Execute then
    Begin
      dest := AusteilPfad+ExtractFileName(OpenDialog1.FileName);
      Try
        CopyFile(Opendialog1.FileName,dest,false);
      except
        on E : Exception do ShowMessage('Fehler'+ret+ret+E.Message);
      end;
      FormShow(nil);
    end;
end;

procedure TAusteilForm.BT_AbbrechenClick(Sender: TObject);
begin
  MResult := mrCancel;
  Close;
end;

procedure TAusteilForm.BT_AusteilClick(Sender: TObject);
var
  n,z : Integer;
  L : String;
begin
  z := 0;
  L := '';
  for n := 0 to CLB_Files.Count-1 do
    Begin
      if CLB_Files.Checked[n]=false then
        Begin
          inc(z);
          L := L + ret+ CLB_Files.Items[n];
        end;
    end;
  If z =0 then
    begin
      MResult := mrYes;
      Close;
    end
  else if MessageDlg('Dateien löschen', 'Möchten Sie die folgenden Dateien ('+IntToStr(z)
                +' Stück) vor dem Austeilen unwiederbringlich löschen und nicht austeilen?'
                +ret+l, mtConfirmation, [mbYes, mbCancel],0) = mrYes  then
    begin
      n :=0;
      Repeat
        if not CLB_Files.Checked[n] then
          Begin
            if FileExists(AusteilPfad+CLB_Files.Items[n]) then
              Begin
                DeleteFile(AusteilPfad+CLB_Files.Items[n]);
              end
            else
              Begin
                ShowMessage('FEHLER!'+ret+ret+'Die Datei existiert nicht:'+ret+AusteilPfad+CLB_Files.Items[n]);
              end;
            CLB_Files.Items.Delete(n);
          end
        else inc(n)
      until (n > CLB_files.Count-1);
      FormShow(nil);
    end;
end;

procedure TAusteilForm.FormShow(Sender: TObject);
Var
  SearchRec  : TSearchRec;
  Found,n    : Integer;
begin
  {$IFDEF WIN64}
    AusteilPfad := 'H:/_auszuteilen/auszuteilen-aktueller_raum/';
  {$ENDIF}
  {$IFDEF LINUX}
    AusteilPfad := GetEnvironmentVariable('HOME')+'/Home_auf_Server/_auszuteilen/auszuteilen-aktueller_raum/';
  {$ENDIF}    CLB_Files.Clear;
  Label1.Caption:='Dateien aus dem Verzeichnis austeilen:'+ret+ret+AusteilPfad;
  Found := FindFirst(AusteilPfad+'*', faAnyFile, SearchRec);
  n := -1;
  while Found = 0 do
    Begin
      if (SearchRec.Name <> '..') and  (SearchRec.Name <> '.') then
        Begin
          if FileExists(AusteilPfad+SearchRec.Name) then
            Begin
              inc(n);
              CLB_Files.AddItem(SearchRec.Name,nil);
              CLB_Files.Checked[n]:=True;
            end;
        end;
      Found := FindNext(SearchRec);
    end;
  FindClose(SearchRec);
  if MyBenutzer<>GetBenutzer then
    Begin
      ShowMessage('Achtung!'+ret+ret+'An der Schulkonsole ist ein anderer Benutzer angemeldet als'+ret+
                  'an diesem PC ('+GetBenutzer+').'+ret+'Die auszuteilenden Dateien sind die Dateien des Benutzers:'+ret+ret+myBenutzer);
      BT_hinzufuegen.Enabled:=false;
      CLB_Files.visible:=false;
      Label1.Caption:=ret+ret+'Dateien aus dem Verzeichnis des Benutzers '+ret+ret+myBenutzer+ret+ret+'werden ausgeteilt.';
    end
   else
     Begin
       BT_hinzufuegen.Enabled:=true;
       CLB_Files.visible:=True;
     end;
end;

end.

